public class DM_Home_dashboard_ctrl {
//with sharing 
	public Integer totalOrignalTarget{get;set;}
    public Integer TotalproposedTarget{get;set;}
    public Integer totalproposedCall{get;set;}
	public Integer totalOrignalCall{get;set;}
    public List<wrapperclass> tablelist {get;set;}
    public List<wrapperclass> tablelist1 {get;set;}
    public List<wrapperclassadded> addedlist {get;set;}
    public List<wrapperclassdropped> droppedlist {get;set;}
    public map<string,map<string,Integer>>mapTerritoryToReasonAdd{get;set;}
    public map<string,map<string,Integer>>mapTerritoryToReasonDrop{get;set;}
    public map<string,map<string,Integer>>mapTerritoryToSegmentAdd{get;set;}
    public map<string,map<string,Integer>>mapTerritoryToSegmentDrop{get;set;}
    public List<wrapperclassadded> addedSegmentlist {get;set;}
    public List<wrapperclassadded> droppedSegmentlist {get;set;}
    public string territoryName {get;set;}
    public string teamInsName {get;set;}
    public string posType{get;set;}
    public String gProfileName{get;set;}
    public string rootPositionId='';
    public map<String,AxtriaSalesIQTM__CIM_Position_Metric_Summary__c> mapTerritoryNameToTotalCalls=new  map<string,AxtriaSalesIQTM__CIM_Position_Metric_Summary__c>();
    public map<String,AxtriaSalesIQTM__CIM_Position_Metric_Summary__c> mapTerritoryNameToTotalTarget=new  map<string,AxtriaSalesIQTM__CIM_Position_Metric_Summary__c>();
    public List<AxtriaSalesIQTM__User_Access_Permission__c> loggedInUserData  {get;set;}
    public Integer notSubmitedCount             {get;set;}  
    public Integer inProgressCount              {get;set;}  
    public string FeedbackStatus1               {get;set;}
    public Integer submitedCount                {get;set;}
    public  map<string,Integer>statusmap = new   map<string,Integer>();     
    
    public list<SelectOption > regionList                    {get; set;}
    public string regionSelected                             {get; set;}
    
    public list<SelectOption> districtList                   {get; set;}
    public string districtSelected                           {get; set;}
    
    public map<ID, list<AxtriaSalesIQTM__Position__c>> mapParentIdPositionId  {get; set;}
   
    public DM_Home_dashboard_ctrl (){
        
        loggedInUserData     = new List<AxtriaSalesIQTM__User_Access_Permission__c>();
        loggedInUserData = SalesIQUtility.getUserAccessPermistion(Userinfo.getUserId());
        gProfileName = [Select Id,Name from Profile where Id=:UserInfo.getProfileId()].Name;
        
        system.debug('loggedInUserData++++'+loggedInUserData);
        if(loggedInUserData!=null && loggedInUserData.size()>0)
        { 
            if(gProfileName =='HO')
            {
                  
                   mapParentIdPositionId = new map<ID, list<AxtriaSalesIQTM__Position__c>>();
                List<AxtriaSalesIQTM__Position__c> allRecs = [select id, name, AxtriaSalesIQTM__Parent_Position__c, AxtriaSalesIQTM__Parent_Position__r.id, AxtriaSalesIQTM__Position_Type__c from AxtriaSalesIQTM__Position__c order by name];
                system.debug('****allRecs '+allRecs);
                List<AxtriaSalesIQTM__Position__c> regionRecs = [select id, name, AxtriaSalesIQTM__Parent_Position__c, AxtriaSalesIQTM__Parent_Position__r.id, AxtriaSalesIQTM__Position_Type__c from AxtriaSalesIQTM__Position__c where AxtriaSalesIQTM__Parent_Position__c =: loggedInUserData[0].AxtriaSalesIQTM__Position__c order by name];
                system.debug('****regionRecs '+regionRecs);
                
                for(AxtriaSalesIQTM__Position__c pos : allRecs)
                {
                    if(mapParentIdPositionId.get(pos.AxtriaSalesIQTM__Parent_Position__r.id) != null){
                        list<AxtriaSalesIQTM__Position__c> positions = new list<AxtriaSalesIQTM__Position__c>(mapParentIdPositionId.get(pos.AxtriaSalesIQTM__Parent_Position__r.id));
                        positions.add(pos);
                        mapParentIdPositionId.put(pos.AxtriaSalesIQTM__Parent_Position__r.id, positions);
                    }
                    else{
                        list<AxtriaSalesIQTM__Position__c> positions = new list<AxtriaSalesIQTM__Position__c>();
                        positions.add(pos);
                        mapParentIdPositionId.put(pos.AxtriaSalesIQTM__Parent_Position__r.id, positions);
                    }
                }
                
                system.debug('****mapParentIdPositionId '+mapParentIdPositionId);
                regionList = new list<SelectOption >();
                
                if(regionRecs != null && regionRecs.size() > 0 )
                    regionSelected = regionRecs[0].id;
                    
                for(AxtriaSalesIQTM__Position__c pos : regionRecs){                  
                    regionList.add(new SelectOption(pos.id,pos.name));
                }
                system.debug('****regionList '+regionList);
                
                districtListChange();
                getTerritorybyLoggedUser();
            }
            else if(gProfileName == 'RM')
            {
            
                 mapParentIdPositionId = new map<ID, list<AxtriaSalesIQTM__Position__c>>();
                 regionSelected = loggedInUserData[0].AxtriaSalesIQTM__Position__c;
                 system.debug('regionSelected++++='+regionSelected);
                
                List<AxtriaSalesIQTM__Position__c> allRecs = [select id, name, AxtriaSalesIQTM__Parent_Position__c, AxtriaSalesIQTM__Parent_Position__r.id, AxtriaSalesIQTM__Position_Type__c from AxtriaSalesIQTM__Position__c order by name];
                system.debug('****allRecs '+allRecs);
                List<AxtriaSalesIQTM__Position__c> districtRecs = [select id, name, AxtriaSalesIQTM__Parent_Position__c, AxtriaSalesIQTM__Parent_Position__r.id, AxtriaSalesIQTM__Position_Type__c from AxtriaSalesIQTM__Position__c where AxtriaSalesIQTM__Parent_Position__c =: loggedInUserData[0].AxtriaSalesIQTM__Position__c order by name];
                system.debug('****districtRecs '+districtRecs);
                
                for(AxtriaSalesIQTM__Position__c pos : allRecs)
                {
                    if(mapParentIdPositionId.get(pos.AxtriaSalesIQTM__Parent_Position__r.id) != null){
                        list<AxtriaSalesIQTM__Position__c> positions = new list<AxtriaSalesIQTM__Position__c>(mapParentIdPositionId.get(pos.AxtriaSalesIQTM__Parent_Position__r.id));
                        positions.add(pos);
                        mapParentIdPositionId.put(pos.AxtriaSalesIQTM__Parent_Position__r.id, positions);
                    }
                    else{
                        list<AxtriaSalesIQTM__Position__c> positions = new list<AxtriaSalesIQTM__Position__c>();
                        positions.add(pos);
                        mapParentIdPositionId.put(pos.AxtriaSalesIQTM__Parent_Position__r.id, positions);
                    }
                }
                system.debug('****mapParentIdPositionId '+mapParentIdPositionId);
                
                
                districtList = new list<SelectOption >();
                for(AxtriaSalesIQTM__Position__c pos : districtRecs)
                {                  
                    districtList.add(new SelectOption(pos.id,pos.name));
                }
                districtSelected = districtRecs[0].id;
                system.debug('****districtList '+ districtList);
                 getTerritorybyLoggedUser();
            }
            else if(gProfileName == 'DM'){
                
                getTerritorybyLoggedUser();
            
            }
            else if(gProfileName == 'Rep')
            {
        		getTerritorybyLoggedUser();
            }
            
        }
        
        //getTerritorybyLoggedUser();
        
    
    }
    
     public void districtListChange()
    {
        system.debug('********distrcit list change function called');
        
        boolean setTerritory = false;
        districtList = new list<SelectOption>();
        
        if(mapParentIdPositionId.get(regionSelected) != null){
            for(AxtriaSalesIQTM__Position__c pos : mapParentIdPositionId.get(regionSelected)){
                districtList.add(new SelectOption(pos.id,pos.name));
                if(setTerritory == false)
                {
                    districtSelected = pos.id;
                    setTerritory = true;
                }
            }
        }
        
        system.debug('****districtList '+districtList);
        getTerritorybyLoggedUser();
        //territoryListChange();
        
    }
    
      public void getTerritorybyLoggedUser(){
        
      
//       droppedlist = new List<wrapperclassadded>();
        
        
        
        rootPositionId='';
        AxtriaSalesIQTM__User_Access_Permission__c access = [Select Id, AxtriaSalesIQTM__Position__c,
                                                AxtriaSalesIQTM__Position__r.Name,AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__Client_Position_Code__c,AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__X_Max__c, AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__X_Min__c, AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__Y_Max__c, AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__Y_Min__c, AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__Position_Type__c,   
                                                AxtriaSalesIQTM__Team_Instance__c, AxtriaSalesIQTM__Team_Instance__r.AxtriaSalesIQTM__Team__c, AxtriaSalesIQTM__Team_Instance__r.AxtriaSalesIQTM__Team__r.Name, AxtriaSalesIQTM__Team_Instance__r.Name, AxtriaSalesIQTM__Team_Instance__r.AxtriaSalesIQTM__Alignment_Type__c ,AxtriaSalesIQTM__Map_Access_Position__c
                                                From AxtriaSalesIQTM__User_Access_Permission__c 
                                                where AxtriaSalesIQTM__Is_Active__c = true AND AxtriaSalesIQTM__User__c =: UserInfo.getUserId() limit 1]; 
            
        system.debug('#### Access Permission : '+ access.Id);
        
        if(gProfileName=='HO' || gProfileName=='RM'){
        
            rootPositionId=districtSelected;
        
        }
        else{
            rootPositionId = access.AxtriaSalesIQTM__Position__c;
        }
        territoryName = access.AxtriaSalesIQTM__Position__r.Name;
        teamInsName = access.AxtriaSalesIQTM__Team_Instance__c;
        system.debug('#### poition and team instance : '+ rootPositionId +'     '+teamInsName+'   '+gProfileName);
        PosType = access.AxtriaSalesIQTM__Position__r.AxtriaSalesIQTM__Position_Type__c;
            
        list<AxtriaSalesIQTM__Position_Team_Instance__c> allAccessiblePositions = [Select id,AxtriaSalesIQTM__Position_ID__c,AxtriaSalesIQTM__Team_Instance_ID__c From AxtriaSalesIQTM__Position_Team_Instance__c p 
                                                        where (AxtriaSalesIQTM__Position_ID__c =: rootPositionId 
                                                        OR AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__Parent_Position__c =: rootPositionId 
                                                        OR AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__Parent_Position__r.AxtriaSalesIQTM__Parent_Position__c =: rootPositionId 
                                                        ) 
                                                        and AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__inactive__c = false 
                                                        and AxtriaSalesIQTM__Team_Instance_ID__c =: teamInsName
                                                        and  AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__Position_type__c='Territory'
                                                        order by Name];
        
        set<string> positionTeamInstanceIds = new set<string>();
        for(AxtriaSalesIQTM__Position_Team_Instance__c teamPos : allAccessiblePositions){
            positionTeamInstanceIds.add(teamPos.id);
        }
        
        set<string> positions = new set<string>();
        for(AxtriaSalesIQTM__Position_Team_Instance__c teamPos : allAccessiblePositions){
            positions.add(teamPos.AxtriaSalesIQTM__Position_ID__c);
        }
        set<string> TeamInstances = new set<string>();
        for(AxtriaSalesIQTM__Position_Team_Instance__c teamPos : allAccessiblePositions){
            TeamInstances.add(teamPos.AxtriaSalesIQTM__Team_Instance_ID__c);
        }
        
        system.debug('--positionTeamInstanceIds '+positionTeamInstanceIds.size()+'     positionTeamInstanceIds   '+positionTeamInstanceIds);
        getTotalTargetAndCall(positionTeamInstanceIds,positions,TeamInstances);
       
    }  
    
      public void getTotalTargetAndCall(set<string> Territory,set<string> positions,set<string> TeamInstances)
      {
       
       	mapTerritoryToReasonAdd= new map<string,map<string,Integer>>(); 
       	mapTerritoryToReasonDrop=new map<string,map<string,Integer>>(); 
       	mapTerritoryToSegmentAdd=new  map<string,map<string,Integer>>();
       	mapTerritoryToSegmentDrop=new  map<string,map<string,Integer>>();
       	addedSegmentlist =new List<wrapperclassadded> ();
   		droppedSegmentlist =new List<wrapperclassadded>();
       	addedlist=new List<wrapperclassadded>();
       	droppedlist=new List<wrapperclassdropped>();
        statusmap.put('Submitted',0);
        statusmap.put('In Progress',0);
        statusmap.put('Not Started',0);
        
        totalOrignalTarget=0;
		TotalproposedTarget=0;
		totalproposedCall=0;
		totalOrignalCall=0;
        
        
      
         //****************** Total Target*********************************************\\
         
          system.debug('Territory+++++++++++++++++++'+Territory);
         List<AxtriaSalesIQTM__CIM_Position_Metric_Summary__c> memb = new List<AxtriaSalesIQTM__CIM_Position_Metric_Summary__c>();  
         list<AxtriaSalesIQTM__CIM_Config__c> cim = [select id , Name from AxtriaSalesIQTM__CIM_Config__c where Name ='No of Targets' and AxtriaSalesIQTM__team_instance__c=:teamInsName];
         String sql = 'select AxtriaSalesIQTM__Proposed__c,AxtriaSalesIQTM__Position_Team_Instance__c, last_cycle__c,AxtriaSalesIQTM__Original__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__isCallPlanSubmitted__c, AxtriaSalesIQTM__CIM_Config__r.Name from AxtriaSalesIQTM__CIM_Position_Metric_Summary__c where AxtriaSalesIQTM__CIM_Config__c =: cim and AxtriaSalesIQTM__Position_Team_Instance__c in: Territory order by AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name';
         memb = Database.Query(sql);
            
         for(AxtriaSalesIQTM__CIM_Position_Metric_Summary__c temp : memb)
         { 
                mapTerritoryNameToTotalTarget.put(temp.AxtriaSalesIQTM__Position_Team_Instance__c,temp);
         
         }
        
        
        //********************Add and Drop  Target********************************\\
        map<String,Integer >addList=new   map<string,Integer>();
        map<string,Integer >dropList=new  map<string,Integer >();
        
        for(AggregateResult pacp:[select count(id) Total, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =false and AxtriaSalesIQTM__isincludedCallPlan__c =true group by AxtriaSalesIQTM__Position_Team_Instance__c  ])
        {
            system.debug('AggregateResult'+pacp);
            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
            Integer value=Integer.valueOf(pacp.get('Total'));
            addList.put(posteamInstance,value);
        }
        
      for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =true and AxtriaSalesIQTM__isincludedCallPlan__c =false group by AxtriaSalesIQTM__Position_Team_Instance__c ])
       {
            String posTeamInstance=String.valueOf(pacp.get('posTeamInst'));
            Integer value=Integer.valueOf(pacp.get('Total'));
            dropList.put(posTeamInstance,value);
            
       
       }
       
       
      
        
        /* for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Picklist3_Updated__c, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name posName  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =true and AxtriaSalesIQTM__isincludedCallPlan__c =false group by AxtriaSalesIQTM__Position_Team_Instance__c,AxtriaSalesIQTM__Picklist3_Updated__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name  ])
        {
            system.debug('AggregateResult'+pacp);
            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
            Integer value=Integer.valueOf(pacp.get('Total'));
            addList.put(posteamInstance,value);
        }*/
        
        //*********************** end**********************************\\
        
        //****************** Total Calls*********************************************\\
        
        List<AxtriaSalesIQTM__CIM_Position_Metric_Summary__c> memb1 = new List<AxtriaSalesIQTM__CIM_Position_Metric_Summary__c>();  
        list<AxtriaSalesIQTM__CIM_Config__c> cim1 = [select id , Name from AxtriaSalesIQTM__CIM_Config__c where Name ='Total Calls' and AxtriaSalesIQTM__team_instance__c=:teamInsName];
        String sql1 = 'select AxtriaSalesIQTM__Proposed__c,last_cycle__c,AxtriaSalesIQTM__Position_Team_Instance__c, AxtriaSalesIQTM__Original__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__Client_Position_Code__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__isCallPlanSubmitted__c, AxtriaSalesIQTM__Position_Team_Instance__r.isCallPlanSaved__c,AxtriaSalesIQTM__Position_Team_Instance__r.Call_Plan_Status__c, AxtriaSalesIQTM__CIM_Config__r.Name from AxtriaSalesIQTM__CIM_Position_Metric_Summary__c where AxtriaSalesIQTM__CIM_Config__c =: cim1 and AxtriaSalesIQTM__Position_Team_Instance__c in: Territory order by AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name';
        memb1 = Database.Query(sql1);   
        
        //---------------------------------
        
        map<string,AxtriaSalesIQTM__Change_Request__c >CRMap=new  map<string,AxtriaSalesIQTM__Change_Request__c >();

        String CRSql = 'select id,name,AxtriaSalesIQTM__Destination_Position__c from AxtriaSalesIQTM__Change_Request__c where AxtriaSalesIQTM__Destination_Position__c in:positions and AxtriaSalesIQTM__Team_Instance_ID__c in:teaminstances Order By AxtriaSalesIQTM__Destination_Position__c,CreatedDate desc';
        List<AxtriaSalesIQTM__Change_Request__c> AllCR = Database.Query(CRSql); 
        if (AllCR.size()>0){
            for (AxtriaSalesIQTM__Change_Request__c tempCR : AllCR){
                if(!CRMap.containskey(tempCR.AxtriaSalesIQTM__Destination_Position__c)){
                    CRMap.put(tempCR.AxtriaSalesIQTM__Destination_Position__c,tempCR);
                }
            }
        }
        system.debug('++++++++++++CRMap'+CRMap);
        
        map<string,string >userposMap=new  map<string,string >();
        
        String upossql = 'Select AxtriaSalesIQTM__User__c,AxtriaSalesIQTM__Position__c from AxtriaSalesIQTM__User_Access_Permission__c where AxtriaSalesIQTM__Position__c in :positions';
        List <AxtriaSalesIQTM__User_Access_Permission__c> userpos = Database.Query(upossql);
        
        for(AxtriaSalesIQTM__User_Access_Permission__c tempuserpos : userpos){
            String uid=tempuserpos.AxtriaSalesIQTM__User__c;
            
            String loginSql = 'select count(id) countoflogin from LoginHistory where userid = \''+uid+'\' group by userid';
            List<AggregateResult> templogin = Database.Query(loginSql); 
            
            if (templogin.size()>0){
                userposMap.put(tempuserpos.AxtriaSalesIQTM__Position__c,String.valueOf(templogin[0].get('countoflogin')));
            }
            system.debug('uid----->>'+uid);
            system.debug('templogin----->>'+templogin);
            
        }
        
        //--------------------------
        
        tablelist= new list<wrapperclass>();
        tablelist1= new list<wrapperclass>();
        
        map<String,Integer> originalCallsMap = new map<String,Integer>();
        map<String,Integer> updatedCallsMap = new map<String,Integer>();
        map<String,Integer> updatedTargetMap = new map<String,Integer>();
        map<String,Integer> originalTargetMap = new map<String,Integer>();
        for (AggregateResult a: [select sum(Original_Calls_Numeric__c) calls,AxtriaSalesIQTM__Position_Team_Instance__c posteam from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isAccountTarget__c = true group by AxtriaSalesIQTM__Position_Team_Instance__c])
        {
            originalCallsMap.put(String.valueOf(a.get('posteam')),Integer.valueOf(a.get('calls')));
        }
        for (AggregateResult a: [select sum(Calls_Numeric__c) calls,AxtriaSalesIQTM__Position_Team_Instance__c posteam  from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isIncludedCallPlan__c = true  group by AxtriaSalesIQTM__Position_Team_Instance__c])
        {
            updatedCallsMap.put(String.valueOf(a.get('posteam')),Integer.valueOf(a.get('calls')));
        }
        for (AggregateResult a: [select count(id) targets,AxtriaSalesIQTM__Position_Team_Instance__c posteam  from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isIncludedCallPlan__c = true  group by AxtriaSalesIQTM__Position_Team_Instance__c])
        {
            updatedTargetMap.put(String.valueOf(a.get('posteam')),Integer.valueOf(a.get('targets')));
        }
        for (AggregateResult a: [select count(id) targets,AxtriaSalesIQTM__Position_Team_Instance__c posteam  from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isAccountTarget__c = true  group by AxtriaSalesIQTM__Position_Team_Instance__c])
        {
            originalTargetMap.put(String.valueOf(a.get('posteam')),Integer.valueOf(a.get('targets')));
        }    
        
        for(AxtriaSalesIQTM__CIM_Position_Metric_Summary__c temp : memb1)
        { 
                mapTerritoryNameToTotalCalls.put(temp.AxtriaSalesIQTM__Position_Team_Instance__c,temp);
                string TerritoryName=temp.AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name;
                string Territorycode=temp.AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.AxtriaSalesIQTM__Client_Position_Code__c;
                string posid=temp.AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__c;
                
                
                system.debug('++++++++++++++++ Territory Name '+ TerritoryName);
                map<string,Integer>mapSegmentToAddcount=new map<string,Integer>();
                 map<string,Integer>mapSegmentTodropcount=new map<string,Integer>();
                mapSegmentToAddcount.put('Low',0);
                mapSegmentToAddcount.put('High',0);
                mapSegmentToAddcount.put('Medium',0);
                mapSegmentTodropcount.put('Low',0);
                mapSegmentTodropcount.put('High',0);
                mapSegmentTodropcount.put('Medium',0);
                mapTerritoryToSegmentAdd.put(TerritoryName,mapSegmentToAddcount);
                mapTerritoryToSegmentDrop.put(TerritoryName,mapSegmentTodropcount);
                system.debug('mapTerritoryToSegmentDrop'+mapTerritoryToSegmentDrop);
                //for filling add  and drop on the reason  code base
                		map<string,Integer>mapReasonCodeToAddcount=new map<string,Integer>();
                		/*mapReasonCodeToAddcount.put('Co-located with Specialist',0);
                		mapReasonCodeToAddcount.put('KOL/Influencer',0);
                		mapReasonCodeToAddcount.put('Next Best Target',0);
                		mapReasonCodeToAddcount.put('Co-located with another Target',0);
                		mapReasonCodeToAddcount.put('None',0);*/
                		
                		
                		mapReasonCodeToAddcount.put('Non-specialist Customer located with specialist',0);
                		mapReasonCodeToAddcount.put('Customer is an influencer',0);
                		mapReasonCodeToAddcount.put('Customer is a KOL/influencer',0);
                		mapReasonCodeToAddcount.put('Customer is a next best target',0);
                		mapReasonCodeToAddcount.put('Customer co-located with target',0);
                		mapReasonCodeToAddcount.put('None',0);
                		mapTerritoryToReasonAdd.put(TerritoryName,mapReasonCodeToAddcount);
                		
                		
                		
                		
                		map<string,Integer>mapReasonCodeToDropcount=new map<string,Integer>();
                		/*mapReasonCodeToDropcount.put('Customer on leave',0);
                		mapReasonCodeToDropcount.put('Alignment Changes',0);
                		mapReasonCodeToDropcount.put('Moved from territory',0);
                		mapReasonCodeToDropcount.put('Retired/Dead',0);
                		mapReasonCodeToDropcount.put('No access',0);
                		mapReasonCodeToDropcount.put('Selling team reassigned',0);
                		mapReasonCodeToDropcount.put('Incorrect address',0);
                		mapReasonCodeToDropcount.put('None',0);*/
                		
                		mapReasonCodeToDropcount.put('Customer on leave',0);
                		mapReasonCodeToDropcount.put('Customer not found',0);	
                		//mapReasonCodeToDropcount.put('Alignment Changes',0);
                		mapReasonCodeToDropcount.put('Moved from territory',0);
                		mapReasonCodeToDropcount.put('Retired/Dead',0);
                		mapReasonCodeToDropcount.put('No Access - Managed markets',0);
                		mapReasonCodeToDropcount.put('No physical access',0);
                		mapReasonCodeToDropcount.put('Drive time',0);
                		mapReasonCodeToDropcount.put('DSI Overlap',0); 
                		mapReasonCodeToDropcount.put('Selling team reassigned',0);
                		mapReasonCodeToDropcount.put('Incorrect address',0);
                		mapReasonCodeToDropcount.put('Due to ZIP movement',0);
                		mapReasonCodeToDropcount.put('None',0);
                		mapTerritoryToReasonDrop.put(TerritoryName,mapReasonCodeToDropcount);
                		
                
                // end
                
                string CRname ='N/A';
                string CRid ='N/A';
                
                if(CRMap.containskey(posid)){
                    CRname=CRMap.get(posid).name;
                    CRid=CRMap.get(posid).id;
                }
                
                
                String logincount='0';//uid+'------'+
                if(userposMap.containskey(posid)){
                    logincount=userposMap.get(posid);
                }
                    
                    //string logincount =templogin[0].countoflogin;
                    
                    /*if (templogin.size()>0){
                        logincount=String.valueOf(templogin[0].get('countoflogin'));//uid+'  '+
                    }*/
                
                
                string FeedbackStatus='';//Not Submitted
                
                FeedbackStatus = temp.AxtriaSalesIQTM__Position_Team_Instance__r.Call_Plan_Status__c;
                
               /* if(temp.AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__isCallPlanSubmitted__c)
                {
                    FeedbackStatus='Submitted';
                    
                    if(statusmap.get('Submitted') != 0){
                            integer rangecount = Integer.Valueof(statusmap.get('Submitted'));
                            statusmap.put('Submitted', rangecount+1);
                    }
                   else
                    {
                            statusmap.put('Submitted', 1);
                    }
                    
                    
                }
                else{
                    if(temp.AxtriaSalesIQTM__Position_Team_Instance__r.isCallPlanSaved__c)
                    {
                        FeedbackStatus='In Progress';
                        if(statusmap.get('In Progress') != 0){
                                integer rangecount = Integer.Valueof(statusmap.get('In Progress'));
                                statusmap.put('In Progress', rangecount+1);
                        }
                       else
                        {
                                statusmap.put('In Progress', 1);
                        }
                        
                    }
                    else{
                        FeedbackStatus='Not Started';
                        if(statusmap.get('Not Started') != 0){
                                integer rangecount = Integer.Valueof(statusmap.get('Not Started'));
                                statusmap.put('Not Started', rangecount+1);
                        }
                       else
                        {
                                statusmap.put('Not Started', 1);
                        }
                        
                    }
                }*/
                
                Integer add=addList.get(temp.AxtriaSalesIQTM__Position_Team_Instance__c);
                Integer drop=dropList.get(temp.AxtriaSalesIQTM__Position_Team_Instance__c);
                if(add==null){
                
                    add=0;
                
                }
                if(drop==null){
                
                    drop=0;
                
                }
                
        AggregateResult aggAdded = [select count(id) countRecs from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isAccountTarget__c = false and AxtriaSalesIQTM__isIncludedCallPlan__c = true and AxtriaSalesIQTM__Position__c =:posid];
                Integer QueryphyAdded = Integer.valueof(aggAdded.get('countRecs'));              
            
                AggregateResult aggDropped = [select count(id) countRecs from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isAccountTarget__c = true and AxtriaSalesIQTM__isIncludedCallPlan__c = false and AxtriaSalesIQTM__Position__c =:posid];
                Integer QueryphyDropped = Integer.valueof(aggDropped.get('countRecs'));
                
        
        AggregateResult aggResultUpdated  = [select count(id) targets, sum(Calls_Numeric__c) calls from AxtriaSalesIQTM__Position_Account_Call_Plan__c where AxtriaSalesIQTM__isIncludedCallPlan__c = true and AxtriaSalesIQTM__Position__c =:posid];
           Integer QueryUpdatedTargets = Integer.valueOf(aggResultUpdated.get('targets'));
           Integer QueryUpdatedCalls = Integer.valueOf(aggResultUpdated.get('calls'));
        
                AxtriaSalesIQTM__CIM_Position_Metric_Summary__c CIMMS=mapTerritoryNameToTotalTarget.get(temp.AxtriaSalesIQTM__Position_Team_Instance__c);
                
                decimal Disruption=QueryphyAdded+QueryphyDropped;//add+drop;
                
                
            String QueryupdatedCallsstring;
            if(String.valueof(QueryUpdatedCalls)!=null){
                QueryupdatedCallsstring = String.valueof(QueryUpdatedCalls);
            }else{
                QueryupdatedCallsstring = '0';
            }
            
            String QueryUpdatedTargetsstring;
            if(String.valueof(QueryUpdatedTargets)!=null){
                QueryUpdatedTargetsstring = String.valueof(QueryUpdatedTargets);
            }else{
                QueryUpdatedTargetsstring = '0';
            }
                
                
                String posTeam = temp.AxtriaSalesIQTM__Position_Team_Instance__r.id;
            system.debug('posTeamIns : ' + posTeam);
            String originalCalls;
            if(String.valueof(originalCallsMap.get(posTeam))!=null){
                originalCalls = String.valueof(originalCallsMap.get(posTeam));
            }else{
                originalCalls = '0';
            }
            String updatedCalls;
            if(String.valueof(updatedCallsMap.get(posTeam))!=null){
                updatedCalls = String.valueof(updatedCallsMap.get(posTeam));
            }else{
                updatedCalls = '0';
            }
            String updatedTargets;
            if(String.valueof(updatedTargetMap.get(posTeam))!=null){
                updatedTargets = String.valueof(updatedTargetMap.get(posTeam));
            }else{
                updatedTargets = '0';
            }
            String originalTargets;
            if(String.valueof(originalTargetMap.get(posTeam))!=null){
                originalTargets = String.valueof(originalTargetMap.get(posTeam));
            }else{
                originalTargets = '0';
            }
            
                
                Integer lastcycleTarget=Integer.valueOf(CIMMS.last_cycle__c);
                if(lastcycleTarget != 0 )
                {
                	Disruption=(Disruption/lastcycleTarget)*100;	
                }
                else
                {
                	Disruption=0;
                }
                
                Disruption=Disruption.setScale(2);
                //Integer changeValue=Integer.valueOf(temp.AxtriaSalesIQTM__Proposed__c)-Integer.valueOf(temp.AxtriaSalesIQTM__Original__c);
                decimal changeValue=0;
               /* if(decimal.valueOf(temp.AxtriaSalesIQTM__Original__c)!=0){
                changeValue=(decimal.valueOf(temp.AxtriaSalesIQTM__Proposed__c)-decimal.valueOf(temp.AxtriaSalesIQTM__Original__c))/(decimal.valueOf(temp.AxtriaSalesIQTM__Original__c));
                }*/
                if(decimal.valueOf(originalCalls)!=0){
                changeValue=(decimal.valueOf(QueryupdatedCallsstring)-decimal.valueOf(originalCalls))/(decimal.valueOf(originalCalls));
                }
                changeValue=(changeValue*100).setScale(2);
                wrapperclass wrapObj=new  wrapperclass(CRname,CRid,posid,TerritoryName ,Territorycode,FeedbackStatus,logincount,temp.last_cycle__c ,/*String.valueOf(updatedCalls)*/QueryupdatedCallsstring ,
            String.valueOf(originalCalls),CIMMS.last_cycle__c,/*String.valueof(updatedTargets)*/QueryUpdatedTargetsstring , String.valueof(originalTargets),
                
                /*,temp.last_cycle__c ,temp.AxtriaSalesIQTM__Proposed__c ,
                temp.AxtriaSalesIQTM__Original__c,CIMMS.last_cycle__c,CIMMS.AxtriaSalesIQTM__Proposed__c , CIMMS.AxtriaSalesIQTM__Original__c,*/ /*add , drop,*/ QueryphyAdded,QueryphyDropped ,  Disruption,changeValue);
        
        
        		totalOrignalTarget=totalOrignalTarget+Integer.valueOf(CIMMS.AxtriaSalesIQTM__Original__c);
	        	TotalproposedTarget=TotalproposedTarget+Integer.valueOf(CIMMS.AxtriaSalesIQTM__Proposed__c);
	        	totalproposedCall=totalproposedCall+Integer.valueOf(temp.AxtriaSalesIQTM__Proposed__c);
	        	totalOrignalCall=totalOrignalCall+Integer.valueOf(temp.AxtriaSalesIQTM__Original__c);
                tablelist.add(wrapObj);
                
                
        }
        for (String key : statusmap.keySet())
                {
                    wrapperclass wrapObj1=new  wrapperclass(key,statusmap.get(key));
                    
                    tablelist1.add(wrapObj1);
                
                }
                system.debug('tablelist1'+tablelist1+'statusmap'+statusmap);
                
                
          // ************segment based add and drop****************
          
          for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Segment8__c segment, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name posName  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =false and AxtriaSalesIQTM__isincludedCallPlan__c =true group by AxtriaSalesIQTM__Position_Team_Instance__c,AxtriaSalesIQTM__Segment8__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name  ])
       	 {
          		system.debug('segment add'+pacp);
	            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
	            String posName=String.valueOf(pacp.get('posName'));
	            String segment=String.valueOf(pacp.get('segment'));
	            Integer value=Integer.valueOf(pacp.get('Total'));
	            if(mapTerritoryToSegmentAdd.containsKey(posName))
	            {
	            	map<string,Integer>tempMapSegmentToAddCount=mapTerritoryToSegmentAdd.get(posName);
	            	for(string key:tempMapSegmentToAddCount.keyset())
	            	{
	            		if(key==segment)
	            		{
	            		
	            			//Integer addCount=tempMapSegmentToAddCount.get(key);
	            			tempMapSegmentToAddCount.put(key,value);
	            		
	            		}
	            	}
	            	mapTerritoryToSegmentAdd.put(posName,tempMapSegmentToAddCount);
	            
	            
	            
	            }
       	 }
       	 
       	  for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Segment8__c segment, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name posName  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =true and AxtriaSalesIQTM__isincludedCallPlan__c =false group by AxtriaSalesIQTM__Position_Team_Instance__c,AxtriaSalesIQTM__Segment8__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name  ])
       	 {
          		system.debug('segment drop'+pacp);
	            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
	            String posName=String.valueOf(pacp.get('posName'));
	            String segment=String.valueOf(pacp.get('segment'));
	            Integer value=Integer.valueOf(pacp.get('Total'));
	            if(mapTerritoryToSegmentDrop.containsKey(posName))
	            {
	            	map<string,Integer>tempMapSegmentToDropCount=mapTerritoryToSegmentDrop.get(posName);
	            	for(string key:tempMapSegmentToDropCount.keyset())
	            	{
	            		if(key==segment)
	            		{
	            		
	            			//Integer addCount=tempMapSegmentToDropCount.get(key);
	            			tempMapSegmentToDropCount.put(key,value);
	            		
	            		}
	            	}
	            	mapTerritoryToSegmentDrop.put(posName,tempMapSegmentToDropCount);
	            
	            
	            
	            }
       	 }
       	 system.debug('mapTerritoryToSegmentDrop2'+mapTerritoryToSegmentDrop);
       	 
       	 //droppedSegmentlist= new list<wrapperclassadded>();
       	  for(string key:mapTerritoryToSegmentDrop.keyset())
          {
          		//map<string ,Integer>tempMap1=mapTerritoryToSegmentAdd.get(key);
          		
          		map<string ,Integer>tempMap2=mapTerritoryToSegmentDrop.get(key);
          		Integer segmentcount1=tempMap2.get('Low');
          		Integer segmentcount2=tempMap2.get('High');
          		Integer segmentcount3=tempMap2.get('Medium');
          		String segment1='Low';
          		String segment2='High';
          		String segment3='Medium';
          		system.debug('segmentcount1++++++++++++'+segmentcount1);
          		wrapperclassadded obj1=new wrapperclassadded(key,'',segmentcount1,segmentcount2,segmentcount3,0,0,0,segment1 ,segment2 ,segment3 ,'' ,'','');
        		droppedSegmentlist.add(obj1);
        		system.debug('obj1+++++++++'+obj1);
       	 
          }
           for(string key:mapTerritoryToSegmentAdd.keyset())
          {
          		//map<string ,Integer>tempMap1=mapTerritoryToSegmentAdd.get(key);
          		map<string ,Integer>tempMap2=mapTerritoryToSegmentAdd.get(key);
          		Integer segmentcount1=tempMap2.get('Low');
          		Integer segmentcount2=tempMap2.get('High');
          		Integer segmentcount3=tempMap2.get('Medium');
          		String segment1='Low';
          		String segment2='High';
          		String segment3='Medium';
          		wrapperclassadded obj=new wrapperclassadded(key,'',segmentcount1,segmentcount2,segmentcount3,0,0,0,segment1 ,segment2 ,segment3 ,'' ,'','' );
        		addedSegmentlist.add(obj);
       	 
          }
          
          system.debug('droppedSegmentlist+++++++'+droppedSegmentlist);
           system.debug('addedSegmentlist+++++++'+addedSegmentlist);
          // *******************8end************************
          
          
          
          // reason code based add and drop
         for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Picklist3_Updated__c reasonCode, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name posName  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =false and AxtriaSalesIQTM__isincludedCallPlan__c =true group by AxtriaSalesIQTM__Position_Team_Instance__c,AxtriaSalesIQTM__Picklist3_Updated__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name  ])
       	 {
	            system.debug('AggregateResult'+pacp);
	            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
	            String posName=String.valueOf(pacp.get('posName'));
	            String reason=String.valueOf(pacp.get('reasonCode'));
	            Integer value=Integer.valueOf(pacp.get('Total'));
	            if(mapTerritoryToReasonAdd.containsKey(posName))
	            {
	            	map<string,Integer>tempMapReasonToAddCount=mapTerritoryToReasonAdd.get(posName);
	            	for(string key:tempMapReasonToAddCount.keyset())
	            	{
	            		if(key==reason)
	            		{
	            		
	            			//Integer addCount=tempMapReasonToAddCount.get(key);
	            			//addCount=addCount+1;
	            			//tempMapReasonToAddCount.put(key,addCount);
	            			tempMapReasonToAddCount.put(key,value);
	            		
	            		}
	            	}
	            	mapTerritoryToReasonAdd.put(posName,tempMapReasonToAddCount);
	            }
	            
	            
        	}
        	
        	 for(AggregateResult pacp:[select count(id) Total,AxtriaSalesIQTM__Picklist3_Updated__c reasonCode, AxtriaSalesIQTM__Position_Team_Instance__c posTeamInst,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name posName  from AxtriaSalesIQTM__Position_Account_Call_Plan__c  where AxtriaSalesIQTM__Position_Team_Instance__c in:Territory and AxtriaSalesIQTM__isAccountTarget__c =true and AxtriaSalesIQTM__isincludedCallPlan__c =false group by AxtriaSalesIQTM__Position_Team_Instance__c,AxtriaSalesIQTM__Picklist3_Updated__c,AxtriaSalesIQTM__Position_Team_Instance__r.AxtriaSalesIQTM__Position_ID__r.Name  ])
       	 	{
	            system.debug('AggregateResult'+pacp);
	            String posteamInstance=String.valueOf(pacp.get('posTeamInst'));
	            String posName=String.valueOf(pacp.get('posName'));
	            String reason=String.valueOf(pacp.get('reasonCode'));
	            Integer value=Integer.valueOf(pacp.get('Total'));
	            if(mapTerritoryToReasonDrop.containsKey(posName))
	            {
	            	map<string,Integer>tempMapReasonToDropCount=mapTerritoryToReasonDrop.get(posName);
	            	for(string key:tempMapReasonToDropCount.keyset())
	            	{
	            		if(key==reason)
	            		{
	            		
	            			//Integer addCount=tempMapReasonToDropCount.get(key);
	            			//addCount=addCount+1;
	            			//tempMapReasonToDropCount.put(key,addCount);
	            			tempMapReasonToDropCount.put(key,value);
	            		
	            		}
	            	}
	            	mapTerritoryToReasonDrop.put(posName,tempMapReasonToDropCount);
	            }
	           
	            
	            
        	}
          
          for(string key:mapTerritoryToReasonAdd.keyset())
          {
          		system.debug('key+++'+key);
          		map<string ,Integer>tempMap=mapTerritoryToReasonAdd.get(key);
          		string reasoncount1='Non-specialist Customer located with specialist';
          		string reasoncount2='Customer is an influencerr';
          		string reasoncount3='Customer is a KOL/influencer';
          		string reasoncount4='Customer is a next best target';
          		string reasoncount5='Customer co-located with target';
          		string reasoncount6='None';
          		
        		
          		
          		
          		Integer reason1=tempMap.get('Non-specialist Customer located with specialist');
          		Integer reason2=tempMap.get('Customer is an influencer');
          		Integer reason3=tempMap.get('Customer is a KOL/influencer');
          		Integer reason4=tempMap.get('Customer is a next best target');
          		Integer reason5=tempMap.get('Customer co-located with target');
          		Integer reason6=tempMap.get('None');
          		
          		
          		wrapperclassadded obj=new wrapperclassadded(key,'',reason1,reason2,reason3,reason4,reason5,reason6,reasoncount1 ,reasoncount2 ,reasoncount3 ,reasoncount4 ,reasoncount5,reasoncount6 );
        		addedlist.add(obj);
          		 system.debug('obj+++++++++++++++'+obj);
          
          }
          for(string key:mapTerritoryToReasonDrop.keyset())
          {
          		map<string ,Integer>tempMap=mapTerritoryToReasonDrop.get(key);
          		string reasoncount1='Customer on leave';
          		string reasoncount2='Customer not found';
          		//string reasoncount3='Alignment Changes';
          		string reasoncount3='Moved from territory';
          		string reasoncount4='Retired/Dead';
          		string reasoncount5='No Access - Managed markets';
          		string reasoncount6='No physical access';
          		string reasoncount7='Drive time';
                string reasoncount8='DSI Overlap'; 
                string reasoncount9='Selling team reassigned';
                string reasoncount10='Incorrect address';
                string reasoncount11='Due to ZIP movement';
                string reasoncount12='None';
          		
          		Integer reason1=tempMap.get('Customer on leave');
          		Integer reason2=tempMap.get('Customer not found');
          		//Integer reason3=tempMap.get('Alignment Changes');
          		Integer reason3=tempMap.get('Moved from territory');
          		Integer reason4=tempMap.get('Retired/Dead');
          		Integer reason5=tempMap.get('No Access - Managed markets');
          		Integer reason6=tempMap.get('No physical access');
          		Integer reason7=tempMap.get('Drive time');
          		Integer reason8=tempMap.get('DSI Overlap');
          		Integer reason9=tempMap.get('Selling team reassigned');
          		Integer reason10=tempMap.get('Incorrect address');
          		Integer reason11=tempMap.get('Due to ZIP movement');
          		Integer reason12=tempMap.get('None');
          		
          		
          		
          		
          		wrapperclassdropped obj=new wrapperclassdropped(key,'',reason1,reason2,reason3,reason4,reason5,reason6,reason7,reason8,reason9,reason10,reason11,reason12,reasoncount1 ,reasoncount2,reasoncount3,reasoncount4 ,reasoncount5,reasoncount6,reasoncount7,reasoncount8,reasoncount9,reasoncount10,reasoncount11,reasoncount12 );
        		droppedlist.add(obj);
          		 system.debug('obj+++++++++++++++'+obj);
          
          }
         // system.debug('addedlist+++++++++++++++'+wrapperclassdropped);
                
                
                
                
      }
    
    public class wrapperclass{
        
        public string changerequest                 {get;set;}
        public string changerequestid               {get;set;}
        public string positionid                    {get;set;}
        public string Territory                     {get;set;}
        public string Territorycode                 {get;set;}
        public string tempList                      {get;set;}
        public string FeedbackStatus                {get;set;}
        //public string OnlineActivity(in mins)       {get;set;}
        public string nooflogins                    {get;set;}
        public string lastCycleCalls                {get;set;}
        public string proposedCalls                 {get;set;}
        public string OrginalCalls                  {get;set;}
        public string lastCycleTarget               {get;set;}
        public string proposedTarget                {get;set;}
        public string originalTarget                {get;set;}
        public Integer add                          {get;set;}
        public Integer drop                         {get;set;}
        public decimal Disruption                   {get;set;}
        public decimal change                       {get;set;}
        public Integer countVal                     {get;set;}  
        
       
         
        public  wrapperclass(string feedback,Integer countVal){
                this.FeedbackStatus=feedback;
                this.countVal=countVal;
              
        }
        public  wrapperclass(string changerequest,string changerequestid,string positionid,string Territory , string Territorycode,string FeedbackStatus,string nooflogins,string lastCycleCalls ,string proposedCalls ,string OrginalCalls,string lastCycleTarget,string proposedTarget ,  string originalTarget,Integer add ,Integer drop,decimal Disruption,decimal change){
            
            this.changerequest=changerequest;
            this.changerequestid=changerequestid;
            this.positionid=positionid;
            this.Territory=Territory;
            this.Territorycode=Territorycode;
            this.FeedbackStatus=FeedbackStatus;
            this.nooflogins=nooflogins;
            
            this.lastCycleCalls=String.valueof(Integer.valueof(lastCycleCalls));
            this.proposedCalls=String.valueof(Integer.valueof(proposedCalls));
            this.OrginalCalls=String.valueof(Integer.valueof(OrginalCalls));
            this.lastCycleTarget=lastCycleTarget;
            this.proposedTarget=proposedTarget;
            this.originalTarget=originalTarget;
            this.add=add;
            this.drop=drop;
            this.Disruption=Disruption;
            this.change=change;
            this.tempList='';
             
        
        }
    }
    
    public class wrapperclassadded{
        
        public string Territory                     {get;set;}
        public string positionid                 {get;set;}
        public Integer reason1                     {get;set;}
       	public Integer reason2                         {get;set;}
        public Integer reason3                       {get;set;}
        public Integer reason4                     {get;set;}  
        public Integer reason5                     {get;set;}
        public Integer reason6                    {get;set;}  
      	public 	String reasonCode1 {get;set;}
      	public 	String reasonCode2 {get;set;}
      	public 	String reasonCode3 {get;set;}
      	public 	String reasonCode4 {get;set;}
      	public 	String reasonCode5 {get;set;}
      	public 	String reasonCode6 {get;set;}
        
       
        public  wrapperclassadded(string Territory,string positionid,Integer reason1 ,Integer reason2 ,Integer reason3 ,Integer reason4 ,Integer reason5,Integer reason6 ,string reasonCode1,string reasonCode2,string reasonCode3,string reasonCode4,string reasonCode5,string reasonCode6){
        	
            this.Territory=Territory;
            this.positionid=positionid;
            this.reason1=reason1;
            this.reason2=reason2;
            this.reason3=reason3;
            this.reason4=reason4;
            this.reason5=reason5;
            this.reason6=reason6;
            this.reasonCode1=reasonCode1;
            this.reasonCode2=reasonCode2;
            this.reasonCode3=reasonCode3;
            this.reasonCode4=reasonCode4;
            this.reasonCode5=reasonCode5;
            this.reasonCode6=reasonCode6;
            
             
        
        }
    }
    
    public class wrapperclassdropped{
        
        public string Territory                     {get;set;}
        public string positionid                 {get;set;}
        public Integer reason1                     {get;set;}
        public Integer reason2                         {get;set;}
        public Integer reason3                       {get;set;}
        public Integer reason4                     {get;set;}  
        public Integer reason5                         {get;set;}
        public Integer reason6                       {get;set;}
        public Integer reason7                     {get;set;} 
        public Integer reason8                    {get;set;}  
        public Integer reason9                   {get;set;}  
        public Integer reason10                   {get;set;}  
        public Integer reason11                    {get;set;}  
        public Integer reason12                   {get;set;}  
        //public Integer reason13                    {get;set;}  
       
      	public 	String reasonCode1 {get;set;}
      	public 	String reasonCode2 {get;set;}
      	public 	String reasonCode3 {get;set;}
      	public 	String reasonCode4 {get;set;}
      	public 	String reasonCode5 {get;set;}
      	public 	String reasonCode6 {get;set;}
      	public 	String reasonCode7 {get;set;}
      	public 	String reasonCode8{get;set;}
      	public 	String reasonCode9{get;set;}        
       	public 	String reasonCode10{get;set;}
       	public 	String reasonCode11{get;set;}
        public 	String reasonCode12{get;set;}
        //public 	String reasonCode13{get;set;}
        public  wrapperclassdropped(string Territory,string positionid,Integer reason1 ,Integer reason2,Integer reason3,Integer reason4,Integer reason5,Integer reason6,Integer reason7,Integer reason8,Integer reason9,Integer reason10,Integer reason11,Integer reason12,string reasonCode1,string reasonCode2,string reasonCode3,string reasonCode4,string reasonCode5,string reasonCode6,string reasonCode7,string reasonCode8,string reasonCode9,string reasonCode10,string reasonCode11,string reasonCode12){
        	
            this.Territory=Territory;
            this.positionid=positionid;
            this.reason1=reason1;
            this.reason2=reason2;
            this.reason3=reason3;
            this.reason4=reason4;
            this.reason5=reason5;
            this.reason6=reason6;
            this.reason7=reason7;
            this.reason8=reason8;
            this.reason9=reason9;
            this.reason10=reason10;
            this.reason11=reason11;
            this.reason12=reason12;
            //this.reason13=reason13;
            this.reasonCode1=reasonCode1;
            this.reasonCode2=reasonCode2;
            this.reasonCode3=reasonCode3;
            this.reasonCode4=reasonCode4;
            this.reasonCode5=reasonCode5;
            this.reasonCode6=reasonCode6;
            this.reasonCode7=reasonCode7;
            this.reasonCode8=reasonCode8;
            this.reasonCode9=reasonCode9;
            this.reasonCode10=reasonCode10;
            this.reasonCode11=reasonCode11;
            this.reasonCode12=reasonCode12;
            //this.reasonCode13=reasonCode13;
             
        
        }
    }

}